      subroutine read_block(fileID, flag,inline,numsat,nobs,satID,
     .  prn,obs,lli)
c     Author: Kristine Larson
c     reads a RINEX observation block, and returns observations and loss of lock
c     indicators (LLI), PRN, etc
      implicit none
      include 'local.inc'
      character*1 char, satID(maxsat)
      integer fileID, i, itrack, flag, nobs, numsat
      integer prn(maxsat), ios, lli(maxob,maxsat)
      character*80 inline, dynfmt, dynfmt2, dynfmt3,anotherline
      real*8 obs(maxob,maxsat) 
      logical debugging
      debugging = .false.
      do i = 1,maxsat
        prn(i) = 0
        satID(i) = ' '
      enddo
      if (flag.le.1 .or. flag.eq.6) then
c       reads satellite names on first line
        read(inline(33:80),'(12(A1,I2))')
     +         (char, prn(i),i=1,12)
        anotherline = inline
        read(inline(33:80),'(12(A1,2x))') (satID(i),i=1,12) 
        if (numsat > 12 .and. numsat < 25) then
c         print*, 'need to read an extra satellite line'
          read(fileID,'(A80)', iostat=ios) inline
          read(inline(33:80),'(12(A1,I2))') (char, prn(i),i=13,numsat) 
          read(inline(33:80),'(12(A1,2x))') (satID(i),i=13,numsat)
        elseif (numsat > 24) then
c         print*, 'need to read two extra satellite lines'
          read(fileID,'(A80)', iostat=ios) inline
          read(inline(33:80),'(12(A1,I2))') (char, prn(i),i=13,24) 
          read(inline(33:80),'(12(A1,2x))') (satID(i),i=13,24)

          read(fileID,'(A80)', iostat=ios) inline
          read(inline(33:80),'(12(A1,I2))') (char, prn(i),i=25,numsat) 
          read(inline(33:80),'(12(A1,2x))') (satID(i),i=25,numsat)
        elseif (numsat > 36) then
          print*, 'Code cannot read more than 36 sats at an epoch'
          call exit
        endif
        if (debugging) then
          do i=1,numsat 
          print*, satID(i),prn(i) 
          enddo
        endif
        
        if (flag .le. 1) then
          do itrack = 1, numsat
            if (nobs.gt.5.and.nobs.le.10) then
c            between 5 and 10 observables
              write(dynfmt, fmt='(A, I3.3, A)')
     +           "(", 5, "(F14.3, i1,1x))"
              write(dynfmt2, fmt='(A, I3.3, A)')
     +           "(" , nobs-5, "(F14.3, i1,1x))"
              read(fileID, fmt=dynfmt, iostat=ios)
     +           (obs(i,itrack), lli(i,itrack), i=1,5)
              read(fileID, fmt=dynfmt2, iostat=ios)
     +             (obs(i,itrack),lli(i,itrack), i=6,nobs)
            else if (nobs.le.5) then
c            less than 6 observables
              write(dynfmt, fmt='(A, I3.3, A)')
     +           "(", nobs, "(F14.3, I1,1x))"
              read(fileID, fmt=dynfmt, iostat=ios)
     +           (obs(i,itrack),lli(i,itrack), i=1,nobs)
            else 
c            more than 10 observables

              write(dynfmt, fmt='(A, I3.3, A)')
     +           "(", 5, "(F14.3, i1,1x))"
              write(dynfmt2, fmt='(A, I3.3, A)')
     +           "(" ,5, "(F14.3, i1,1x))"
              write(dynfmt3, fmt='(A, I3.3, A)')
     +           "(" , nobs-10, "(F14.3,i1,1x))"

              read(fileID, fmt=dynfmt, iostat=ios)
     +           (obs(i,itrack), lli(i,itrack), i=1,5)
              read(fileID, fmt=dynfmt2, iostat=ios)
     +             (obs(i,itrack),lli(i,itrack), i=6,10)
              read(fileID, fmt=dynfmt2, iostat=ios)
     +             (obs(i,itrack),lli(i,itrack), i=11,nobs)



            endif
            if (debugging) then
            print*, itrack, satID(itrack), prn(itrack),
     .       obs(7,itrack), obs(8,itrack), obs(9,itrack)
            endif
          enddo
        endif
      else
c       I think these are comment lines or similar
        do itrack = 1, numsat
          read(fileID, fmt='(A80)', iostat=ios) inline
        enddo
      endif
      if (debugging) then
        print*, 'return from read_block'
      endif
      end
